FORMA LMS
RELEASE CHANGELOG

---------------------------------------------------------------------------------------
forma.lms 4.0.19
---------------------------------------------------------------------------------------
Release date: 2025 July

- #     - fix check if set HTTP_X_FORWARDED_FOR  before use
- #     - add div and css class to course-box__title for course name into course box
- #     - fix course block rendering  if "use_course_label" is on
- #     - fix download if file not exists
- #     - Upgrade legacy to version 3.3.26 + SQL_MODE from NO_AUTO_CREATE_USER to NO_ENGINE_SUBSTITUTION
- #     - Fix Test with feedback: error 500
- #     - Include column filters in search query during global search.
- #     - Prevent column search event during global search.
- #     - added search timeout and enabled search on submit button
- #     - fix column in import subscription
- #     - update german translate
- #     - fix exception in HomepageAdmController.php 
- #     - fix base url management in Get::site_url function 
- #     - fix base url management in getCurrentDomain function
- #     - fix catalogue subscription email
- #     - fix and refactor course userCanUnsubscribe function 
- #     - fix dashboard block calendar
- #     - fix group query
- #     - fix exception BaseCache::__wakeup()
- #     - add lang cache to config
- #     - fix lang translate month
- #     - fix CourseLms
- #     - implement API for multiple users
- #     - improve course date begin and date end management
- #     - fix date translate
- #     - add clear lang cache
- #     - fix lang load when new lang is installed
- #     - Implement Abstract BaseCache to extends cache for generic use
- #     - complete lang cache implementation
- #     - wip implementation
- #     - Fix dashboard exception
- #     - add show_custom_fields to usersList API to return custom fields data in users list
- #     - fix in API userDetails to show custom fields that user cannot view.
- #     - add getCategories API
- #     - Change SQL_MODE from NO_AUTO_CREATE_USER to NO_ENGINE_SUBSTITUTION for mysql 8.0 compatibility
- #     - fix field_access_list in  lib.user_profile
- #     - Add event "core.users.changestatus" in suspend/unsuspend user/users
- #     - Fix myMetaCertificate function that does not return correct rows when i've two meta certificate that use the same idCertificate
- #     - preg_match does not fall in catch branch in case of time format different from PT time; managed with if instruction.
- #     - fix DbConn::getInstance to solve automatically the connection and not using external connection link
- #     - Implement db factory interface 
- #     - activate Plugin namespace
- #     - fix coursereport
- #     - replace old require with forma::include
- #     - fix getDateSubscribed to get correct user for teacher
- #     - fix(dateTimeLocal): empty values
- #     - Fix actual space in CourseLmsController
- #     - fix(bonusScore): put all statuses in scores query
- #     - fix access to courses and lo objs
- #     - fix data_end in courseAlms
- #     - fix session save on org chart
- #     - fix migration namespace
- #     - fix api getAnswerQuest 
- #     - fix gift import order
- #     - fix create course date_begin, date_end to set NULL when parameters are blank
- #     - fix create and update course hour_begin, hour_end when parameters are blank
- #     - add Migration to update wrong hour_begin, hour_end setted to ':'
- #     - replace migration to update single column
- #     - fix classroom update on API
- #     - fix accessSelection in UserselectorAdmController
- #     - fix update classroom to manage textfield update
- #     - fix location api
- #     - fix dashboard block
- #     - fix error in dashboard when permissions are not set.
- #     - fix day custom field api
- #     - fix duplicate answer in class choices
- #     - fix api getAnswerTest to get one only couple idAnswer , idQuest
- #     - fix(catalogue): complete access for superadmin in any condition
- #     - chore(admins): delete from admin tree reference if admin changed level or is deleted
- #     - fix send mail to moderators during import into course
- #     - fix waiting approval entering courses
- #     - fix can enter course in catalogue by date interval


---------------------------------------------------------------------------------------
forma.lms 4.0.11
---------------------------------------------------------------------------------------
Release date: 2024 October

- #     - add translate and fix keys form cron.report
- #     - fix absolute path calculate
- #     - fix right join coursereports for not test items
- #     - fix insertparams
- #     - fix unjoinead course reports on learning course reports
- #     - update certificate generation
- #     - update composer packages
- #     - fix clean selection from empy values in userselector
- #     - fixed mail sender
- #     - fix org nodelist dropdown query
- #     - fix null values in courselist
- #     - fix getAllselection from UserDataSelector.php
- #     - fix admin courselist data
- #     - fix api
- #     - mycourses - filter closed couse in "all course" mycourses
- #     - fix sequence questions test on delete
- #     - fix exception stats when user is tutor - fix division by zero when turo does not have any student
- #     - fix get pdf constructor
- #     - fix api authentication not neded for explicit route
- #     - Fix autoplay object
- #     - fix Man_course in certificate.php


---------------------------------------------------------------------------------------
forma.lms 4.0.10
---------------------------------------------------------------------------------------
Release date: 2024 july

- #     - Update Rest API 
- #     - fix rest api buffer
- #     - fix enroll users list
- #     - update forma version
- #     - fix calendar pop-up and colors

---------------------------------------------------------------------------------------
forma.lms 4.0.9
---------------------------------------------------------------------------------------
Release date: 2024 july


- #      -fix typo in install.adm
- #      -fix typo
- #      -fixed check box value
- #      -fix error in sendRegistration of reservation registration - other minor fixes
- #      -fix privilege escalation in "Other actions" menu.
- #      -review question types
- #      -Fix prerequisites check and mySQL 8 query handling.
- #      -Fix suspension attempts handling and prerequisites check
- #      -fix require forma inc
- #      -fix migrazioni
- #      -fix mailconfig for mysql compatibility
- #      -fix warning in coursereport
- #      -coursereport improve performance
- #      -add forma::inc in lib.permissions.php require_once
- #      -fix coursereport
- #      -fix lang and remove migration
- #      -fix procedure
- #      -fix migrations
- #      -fix migrations
- #      -fixing unsubscribe procedure for learning course path
- #      -added helper function for checking field existence
- #      -Fix select data order by translation
- #      -fix get-idstudent not only students
- #      -fix installer and upgrader autocomplete and events
- #      -error in the function interface
- #      -add participant event - add course subscribed event
- #      -fix coursereportmanager in userprofile
- #      -fix coursereport gradebook views
- #      -fix not-checked test showing in coursereport
- #      -fix test error
- #      -fix import on node iwth custom fields
- #      -fix time scorm
- #      -fix drop index if not exist in incorrect table learning_quest_type instead of learning_coursereport
- #      -fix subscribe include
- #      -fix coursereport
- #      -fix migration for perms
- #      -set mysql session variable group_concat_max_len  for big selection of users
- #      -fix coursestats timeToSec function
- #      -fix migrations
- #      -increase bootstrap Boot::Init logic to load dynamically custom sequence from constants - Fix doctrine migration when doctrine has executed from command line
- #      -fix from 3323
- #      -update CoursereportManager
- #      -fix query from 3323
- #      -revert Sessionmanager
- #      -fix iCal send and generation
- #      -fix generate token in API lib
- #      -fix unique insert in learning coursereport
- #      -PHP 7.4 compatibility: funcion parameters ...$parm  (in upgrade)
- #      -PHP 7.4 compatibility: funcion parameters ...$parm  (in cron report)
- #      -PHP 7.4 compatibility: funcion parameters ...$parm  (in communications and in multiple subscriptions)
- #      -Added block for plugin customization
- #      -fix cc and ccn emails
- #      -Migration - Fixed update error - Syntax error or access violation: 1071 Specified key was too long; max key length is 1000 bytes + DEV alignment
- #      -Fix course report overview test name and other columns was misallined - Fix poll tracking
- #      -Fixed update error - Syntax error or access violation: 1071 Specified key was too long; max key length is 1000 bytes
- #      -Upgrade Legacy version formalms 3.3.22
- #      -fix import from file csv and replace while instead foreach
- #      -fix warning in LoData and in test.php
- #      -fix remove day
- #      -fix admin subnode org chart view
- #      -fix step report user courses
- #      -fix add child node in usermanagement
- #      -add select all in newsletter feature
- #      -fix course sheet update from lms side
- #      -fix tracking material
- #      -fix total accesses coursestats
---------------------------------------------------------------------------------------
forma.lms 4.0.7
---------------------------------------------------------------------------------------

- #      - upgrade manifest standard
- #      - fix icon plus
- #      - Fix test points
- #      - Fix test session time
- #      - fix editor
- #      - review fix add folder warning
- #      - fix typo in add communication view
- #      - Fix default date in communìcations, fix warnings in add node
- #      - fix exception when bootstrap was loaded from commandline
- #      - improve course report loading
- #      - fix error in deleting rows classdates
- #      - update forma version
- #      - fix installer
- #      - fix array key session
- #      - fix session conflict
- #      - fix detail user in object stats
- #      - add new userseelctor catalogue
- #      - rename migration name
- #      - fix slider menu
- #      - remove mintemplateversion old style
- #      - fix compatibility 7.4 for forma 4
- #      - Fixed button in "Scheda corso"
- #      - fix prerequistes in susponsion LO with incomplete selfrequisite
- #      - fix migration privacy policy menu
- #      - update template
- #      - fix coursereport testvote
- #      - fix rest output file
- #      - fix null value userselector old
- #      - Build frontend eduardo commits
- #      - add symfony string library
- #      - add event for util config
- #      - refactor min forma version
- #      - fix show answer in course report
- #      - Fix "Download" button position on "MyCertificates" user area	62ba3a8d2	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 20:00
- #      - Fix handling accents when right click renaming	9c8b77412	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 17:06
- #      - Fix FolderView delete file message not showing	fd0c868fe	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 15:33
- #      - Fix Context Menu delete message not showing	5091f62c2	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 15:04
- #      - Fix Link header translation	a165207b3	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 14:47
- #      - Change submit when editing a file to orange	e3a125d84	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 14:21
- #      - Remove double quote on edit dashboard settings and directory class	d544bf001	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 13:49
- #      - Remove double '<<' on Wiki module	1ddc63070	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 13:41
- #      - Fix invalid lang codes for language files	6d5fb2a3b	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 13:37
- #      - Fix "X" alignment on file dropzone and upgraded TinyMCE to 5.10.9	ea7895031	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 13:21
- #      - Remove double '<' on User Registration	7f644dd33	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 12:57
- #      - Fix FAQ title rendering	700e2a677	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 11:09
- #      - Fix PT-BR install translation and translates "Yes/No" fields	c9c48e727	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 10:40
- #      - Fix reference for missing image on FAQ	1596eedc6	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 09:07
- #      - Make Admin Area icons sprite transparent	0ef0e21b7	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 09:00
- #      - Merge branch 'patch-18'	0aa60511b	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 08:42
- #      - Translate Status column and Capitalize "by" column	aa80d9fcc	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	24 Jan 2024 at 21:05
- #      - Merge remote-tracking branch 'origin/patch-17'	16251d4d6	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 08:41
- #      - Fix _MOVE_ORGBRANCH translation	90765c244	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	24 Jan 2024 at 20:58
- #      - Update kbcategorize.php	f568eea36	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	24 Jan 2024 at 20:49
- #      - Update _orgchart_selector.php	cd7b4dcf1	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	24 Jan 2024 at 20:46
- #      - Merge remote-tracking branch 'origin/patch-16'	b0285e2b3	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 08:41
- #      - Translate User Pontuation column tile on Grade book details	bb6d4e0d5	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	24 Jan 2024 at 19:34
- #      - Merge branch 'patch-15'	ffc849b6d	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 08:41
- #      - Pass dropzone as Twig param	48ce552d1	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	24 Jan 2024 at 19:25
- #      - Translate success upload learning object file message	0ec3144cd	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	24 Jan 2024 at 19:24
- #      - Merge remote-tracking branch 'origin/patch-14'	4a4503c06	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 08:41
- #      - Fix translation label rendering on checkboxes at student attendance list	9be067fc3	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	24 Jan 2024 at 15:29
- #      - Merge remote-tracking branch 'origin/patch-13'	a785c03d0	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 08:39
- #      - Fix "modify time table" on student attendance dates list	1a0c49e98	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	24 Jan 2024 at 15:05
- #      - Merge branch 'patch-12'	327a8a75c	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 08:39
- #      - Fix searchbox float of certificates	f4e59d70b	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	23 Jan 2024 at 22:04
- #      - Update certificate.userstat.php	126b528af	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	23 Jan 2024 at 19:29
- #      - Merge branch 'patch-11'	9045e13c2	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 08:39
- #      - FolderView translation handling	e567f61a2	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	18 Jan 2024 at 19:19
- #      - Add translation for Context Menu and Folder View actions on courses	612955315	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	18 Jan 2024 at 19:18
- #      - Merge remote-tracking branch 'origin/patch-10'	6fd45f167	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 08:38
- #      - Translate fields from User Profile (View)	15a1781cc	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	18 Jan 2024 at 18:25
- #      - Merge remote-tracking branch 'origin/patch-9'	0ba72134f	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 08:37
- #      - Update lostpwd.html.twig	608eada26	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	18 Jan 2024 at 14:54
- #      - [User Register] Remove '<<' from _BACK str and Uppercase on language dropdown	4fcf73ae0	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	18 Jan 2024 at 14:47
- #      - Merge remote-tracking branch 'origin/patch-8'	2288dd75e	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 08:37
- #      - Add missing space on Users section of dashboard	2f05e7ba1	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	18 Jan 2024 at 13:24
- #      - Merge remote-tracking branch 'origin/patch-7'	ec860c608	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 08:37
- #      - Fix subscribe user "plus" button on assign users to course page	a4f0d30c2	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	18 Jan 2024 at 13:18
- #      - Merge remote-tracking branch 'origin/patch-6'	0bccda71a	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 08:36
- #      - Do not use slashes on _homerepo and _repo DB	e5506c612	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	18 Jan 2024 at 15:13
- #      - Saves data on DB with slashes	a35187aa8	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	18 Jan 2024 at 11:21
- #      - Fix HTML page title rendering (and possible other learning objects too)	e5fb31e4e	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	18 Jan 2024 at 11:19
- #      - Merge remote-tracking branch 'origin/patch-5'	7b31e1bf6	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 08:36
- #      - Fix 404 error when loading jQuery Datepicker for EN users	64a64fc15	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	18 Jan 2024 at 10:45
- #      - Merge remote-tracking branch 'origin/patch-4'	e589c8e5a	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 08:36
- #      - Update show.php	135f38231	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	18 Jan 2024 at 05:08
- #      - Update list.php	bd5c135b1	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	18 Jan 2024 at 05:08
- #      - Fix translation not being applied on Language management	fd2dd12dd	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	18 Jan 2024 at 05:07
- #      - Merge remote-tracking branch 'origin/patch-3'	6fe5df60b	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 08:36
- #      - Fix radio text alignment	2aae4b960	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	17 Jan 2024 at 18:15
- #      - Merge branch 'patch-2'	f73c0fcff	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 08:33
- #      - Fix "Menu Course" translation	9d0baa649	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	16 Jan 2024 at 19:28
- #      - Merge remote-tracking branch 'origin/patch-1'	a0bf1d4a3	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	25 Jan 2024 at 08:31
- #      - Fix translation not being applied on Teacher Area	b3c1e68da	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	16 Jan 2024 at 19:13
- #      - Added missing translation relations	597ec63f1	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	18 Jan 2024 at 11:38
- #      - Multilanguage TinyMCE and bugfixes	7d72f15e7	Eduardo Mozart de Oliveira <2974895+eduardomozart@users.noreply.github.com>	18 Jan 2024 at 10:34
- #      - fix null selection on report
- #      - add indexes
- #      - fix helpdesk js
- #      - fix exception in test compeltion
- #      - various fix for customers' bug
- #      - events on userselector columns
- #      - #20192: changed twig directive; changed type of parameter parsing
- #      - fix exception in registration
- #      - fix auto subscription
- #      - fix null value in UserSelectorAdmController
- #      - # 20191: wrong method refereer
- #      - # Added new SECURITY Tab; added strong password definition policies; changed password feedback dialog when user defines new password. Fixed some issue in password check;  password check procedure now in just one place. Deleted rubbish.
- #      - fix scorm time parser
- #      - update version
- #      - fix scorm sessiontime count
- #      - fix sql fetch row on result
- #      - fix report excluding all idst selected
- #      - add user selection field to report
- #      - #20190: disable secure if on localhost
- #      - Track answer resetting issue
- #      - fix connector import user language logic
- #      - fix htmlpage update query
- #      - fix report with no selection
- #      - remove comments
- #      - fix box height
- #      - #20189: fixed
- #      - #20188: fixed
- #      - null value in orgnode domain config
- #      - #20187: added check on var type
- #      - # fixed issue in importing GIFT files containing multiple choice questions
- #      - #added force SCORM finish from LMS as configuration option (default TRUE)
- #      - Added forcing SCORM Finish from platform (default true)
- #      - -restore learning test columns altered
- #      - #20186: fixed referring to parent properies
- #      - remove gradimento form learning test
- #      - enabled overide of course catalogue boxes
- #      - Enabled layout scorm player for lti-external-tool learning objects.
- #      - fix session handling in cron
- #      - #20185: refactoring CoursePath
- #      - Added DrawRadialProject.js and scss in frontend-src
- #      - fix session name for security
- #      - session secure
- #      - sanitize wildcard in check username duplicates
- #      - fix default lang in io task user import
- #      - fix calendar
- #      - remove course description in getanswertest XML response
- #      - fix multimod subscription in users array
- #      - Add new event in certificate generation/deleting
- #      - prevent db empty exception on installation with config file
- #      - fix orphan commontrack
- #      - #20181 - Student upload a Zip file through the plugin upload
- #      - #20180 - Student upload a Zip file through the SCORM importer feature
- #      - fix report and sms mamanger
- #      - fix groupmanagement acl
- #      - fix static function call
- #      - fix mailer and advanced search
- #      - #20179 - SQL injection vulnerability in appLms/ajax.adm_server.php?r=widget/userselector/getusertabledata - CVE-2022-42924
- #      - #20070 - Vulnerability - SQL Injection in adm/mediagallery/delete - CVE-2022-42923
- #      - #20069 - Vulnerability - XSS in appLms/index.php?modname=faq&op=play - CVE-2022-41679
- #      - #20177 - Vulnerability reflected-XSS in the title of discussions in the course forums - CVE-2023-46693
- #      - #20178 - Vulnerability reflected-XSS in management of educational objects, through the FAQ title - CVE-2023-46693
- #      - #20176 - Vulnerability reflected-XSS in the title parameter of the course advice - CVE-2023-46693
- #      - fix typo in smtp password property handler
- #      - fix lib.subscribe.php exception
- #      - update composer libraries
- #      - fix track object static properties definition and usage.
- #      - fix typo in advice
- #      - fix course end date when course_date is null
- #      - fix soaplms adding not defined class properties
- #      - fix system status check screen
- #      - Fix learning object visibility for students.
- #      - add migration to reset from 0000-00-00 00:00:00 to null learning object visibility.
- #      - update to changelog
- #      - update readme
- #      - #20175: fixed typo
- #      - #20174: fixed navigation with keyboard inside course's LOs, sized some fonts to 12px
- #      - remove canRelExceptional function
- #      - Upgraded template version number
- #      - #20173: added highlight on focus of LO items
- #      - add not assigned option in folder template and required domain and title in admindomain
- #      - reverted back tinymce component
- #      - Fixed issues related to classroom courses in calendar widget; improved accessibility for course date classroom courses popup.
- #      - fix mod template in node selectors
- #      - fix to be suitable with foxis
- #      - fix userselector on report updates
- #      - # deleting unused files
- #      - fix smtp disabled in config file
- #      - fix typo
- #      - fix and change version
- #      - fix connectors
- #      - fix exception for wrong namespace
- #      - fix mail config
- #      - #20172 Removing Yui editor
- #      - update readme with migration commands
- #      - fix on assigning template in creating new folder
- #      - #20171 Added "custom fields" info related to course when getting course info for rendering on "my courses"
- #      - fix on untranslated custom field
- #      - Fix dashboard clone
- #      - #20157: improvement related to accessibility
- #      - #20170 fixed typo
- #      - new events "core.index.preoperation" and "core.index.beforenavigation" in appCore and appLms
- #      - fix dates, competences and release 4.0.3
- #      - #20157: fixed issues related to help desk and other minor fixes
- #      - entity allignment
- #      - Fix require_once with Forma::inc
- #      - #20157 update for managing HIGH contrast color
- #      - ripristinate buttons
- #      - add reset_field_if_not_set,use_default_password,default_password in iotask docebouser connector config
- #      - add orgchart management in update user api
- #      - various fix userselector
- #      - #20169; added array declaration
- #      - #20166: fix typo in missing array declaration
- #      - Bug #20168: fixed id parameter for deleting record; added console output in case of debug = YES setting.
- #      - remove class references use
- #      - fix report create
- #      - fix query for field show when textentry is numeric when fields filter is active
- #      - refactor entities
- #      - #20167: names removed
- #      - fix custom field check when user insert 0 as value
- #      - fix custom field check when user insert 0 as value
- #      - #20166: missing array declaration
- #      - #20165; added static keyword
- #      - #20162: user import issues: added mime type + declared array
- #      - Removed accessibility function
- #      - Added pseudo-class :focus-visibility
- #      - #20161: added managing of default null value
- #      - fix 0 user search field
- #      - #20160: orgFieldPublishTo date format not managed with default DB value.
- #      - Fixed keyboard navigation focus
- #      - fix version compare
- #      - Remove double addslashes() in Scorm_Organization
- #      - Fix getPreference language in (external) login
- #      - Fix accessibility
- #      - Fix accessibility (course button)
- #      - Help desk accessibility bug fixed
- #      - Bug fixed accessibility buttons margin padding
- #      - fix typo in lib.certificate.php
- #      - # 20157: changed tab managment to be more compatible with Accessibility
- #      -  #20157: managing of some alerts reported by WebAIM tool
- #      - fix field show when textentry is numeric
- #      - Fix user selector exception
- #      - fix group update
- #      - #20157 different fixex for accessibility
- #      - Fix course catalog implode exception when catalog filter does not return array
- #      - # different fixes for accessibility
- #      - fix missing variables and referrals
- #      - fix tree data
- #      - event fors profile and user area lms
- #      - minor bug fix forma-button
- #      - fix minor bug
- #      - # different fixes for accessibility
- #      - event fors profile and user area lms
- #      - fix tree data
- #      - .course-box__cta__button:focus fixed
- #      - accessibility fixed
- #      - # fixes for accessibility
- #      - last fixes after accessiblity
- #      - Fixed chechbox tabindex
- #      - # managing tab navigation inside course
- #      - cols and buttons for recovery psw and email
- #      - fixed underline
- #      - fixed filterbtn hover color
- #      - Modified and fixed the button colors on the tabulation
- #      - Fixed input and button position
- #      - # different
- #      - # SCSS update
- #      - Accessibility
- #      - Modified background color
- #      - Fix icons course page
- #      - # implemented tab navigation on my courses
- #      - # implemented useri interaction through tab key on my courses page
- #      - Fix border dropdown corsi
- #      - Aggiunte classi css per accessbilità
- #      - # managing tabs for course box
- #      - # managing focus style
- #      - # tab navigation management
- #      - # Managing tab navigation in myCouse button
- #      - # improved tabs view
- #      - # added tab navigation in main front end menu + other fixes
- #      - # different changes for enabling right navigation through keyboard keys (TAB, ENTER) - part 1
- #      - # management of page for <title> html tag
- #      - #accessibility help desk panel refactoring 1
- #      - #accessibility update
- #      - # different changes for enabling right navigation through keyboard keys (TAB, ENTER) - part 1
- #      - # accessibility fixed typo
- #      - #Accessibility: added management of landing forma page.
- #      - remove PageName from index and twig
- #      - Remove $GLOBALS['page_title'] and consolidate pageTitle generation in single function
- #      - # update for accessibility
- #      - # different update for accessibility
- #      - # Added TITLE in the SELECT in MyCourses -> Tab for filtering courses
- #      - # management of page for <title> html tag
- #      - make inheritance of sslencryption
- #      - switch to 4.0.2 - drop index if exists for mysql5.7 implementation

---------------------------------------------------------------------------------------
forma.lms 4.0.4
---------------------------------------------------------------------------------------
Release date: 2023 november

- #      - fixes and implementations for accessibility
- #      - fix userselector on report updates
- #      - # deleting unused files
- #      - fix smtp disabled in config file
- #      - fix connectors
- #      - fix mail config
- #      - #20172 Removing Yui editor
- #      - fix on assigning template in creating new folder
- #      - #20171 Added "custom fields" info related to course when getting course info for rendering on "my courses"
- #      - fix on untranslated custom field
- #      - Fix dashboard clone
- #      - new events "core.index.preoperation" and "core.index.beforenavigation" in appCore and appLms
- #      - fix dates, competences and release 4.0.3
- #      - #20157: fixed issues related to help desk and other minor fixes
- #      - add reset_field_if_not_set,use_default_password,default_password in iotask docebouser connector config
- #      - add orgchart management in update user api
- #      - various fix userselector
- #      - Bug #20168: fixed id parameter for deleting record; added console output in case of debug = YES setting.
- #      - fix report create
- #      - fix query for field show when textentry is numeric when fields filter is active
- #      - #20167: names removed
- #      - fix custom field check when user insert 0 as value
- #      - #20165; added static keyword
- #      - #20162: user import issues: added mime type + declared array
- #      - Added pseudo-class :focus-visibility
- #      - #20161: added managing of default null value
- #      - #20160: orgFieldPublishTo date format not managed with default DB value.
- #      - fix version compare
- #      - Remove double addslashes() in Scorm_Organization
- #      - Fix getPreference language in (external) login
- #      - fix typo in lib.certificate.php
- #      - fix field show when textentry is numeric
- #      - fix group update
- #      - Fix course catalog implode exception when catalog filter does not return array
- #      - fix missing variables and referrals
- #      - fix tree data
- #      - event fors profile and user area lms
- #      - last fixes after accessiblity
- #      - Fixed chechbox tabindex
- #      - # managing tab navigation inside course
- #      - cols and buttons for recovery psw and email
- #      - Modified and fixed the button colors on the tabulation
- #      - Fix icons course page
- #      - # implemented useri interaction through tab key on my courses page
- #      - # managing focus style
- #      - # added and improved tabs view
- #      - # Added TITLE in the SELECT in MyCourses -> Tab for filtering courses
- #      - # management of page for <title> html tag
- #      - make inheritance of sslencryption
- #      - drop index if exists for mysql5.7 implementation
- #      - fix on zero date after tests
- #      - substition zero date with nullable dates
- #      - fix session in select node usermanagement
- #      - add fallback to ',' '|' and space separator fo CC and CCN in mailer
- #      - Enabled scorm player for xAPI learning objects.
- #      - substitution image default for courses
- #      - removed font file with wrong camel case in name
- #      - fix installer

---------------------------------------------------------------------------------------
forma.lms 4.0.1
---------------------------------------------------------------------------------------
Release date: 2023 august

- #      - fix on zero date after tests
- #      - other substitutions of zero date
- #      - substition zero date with nullable dates
- #      - fix session in select node usermanagement
- #      - add fallback to ',' '|' and space separator fo CC and CCN in mailer
- #      - Enabled scorm player for xAPI learning objects.
- #      - substitution image default for courses
- #      - fix wrong filename
- #      - removed font file with wrong camel case in name
- #      - fix installer
- #      - update maturity

---------------------------------------------------------------------------------------
forma.lms 4.0.0
---------------------------------------------------------------------------------------
Release date: 2023 july

- #      - fix substring on registration code
- #      - fix countryfields and setting exclusions
- #      - fix color formatable not striped
- #      - various fix for area lms
- #      - fix newsletter, messages and forum export
- #      - fix settings and color datatable
- #      - fix helpdesk form
- #      - fix sender event and save dates in classroom
- #      - fix installer
- #      - Fix root required field in advanced registration when there isn't reg code
- #      - fix for custom domain settings
- #      - integration for domain config pulgins
- #      - fix classroom day management
- #      - fix config on upgrader and some fixes for events
- #      - fix(feedback): percentage score correctly pinted
- #      - finish userselector
- #      - fix back_url type
- #      - fix installer and orgnodeaccessprocessor
- #      - Userselector select/deselect all final?
- #      - change frontend build configurations
- #      - fix command for unminified css
- #      - fix test dletion with coursereport instances
- #      - Userselector select/deselect all
- #      - fix for mysql 2
- #      - fix for php74 and mysql compatibility
- #      - last fixes in user data selector
- #      - userselect checkbox select all
- #      - end userselector
- #      - fix lang get
- #      - fix performance exception
- #      - fullcalendar tooltip fix
- #      - userselector
- #      - fix frontend dashboard calendar
- #      - fix insert pluginmanageradm
- #      - fix input filter
- #      - fix certificate list
- #      - fix forum and warning in orglib
- #      - fix learning object
- #      - fix dashboard blocks
- #      - fix installer and upgrader
- #      - fixes buttons search
- #      - put "register and "lost password links under "local" login part
- #      - fix userselectors
- #      - copy images
- #      - Userselector + filter fixes
- #      - update icons
- #      - fix test update modality
- #      - fix 81 parte 8
- #      - icona svg
- #      - fix - MUselect + Foldertree
- #      - fix login button color - fix module instance require path
- #      - finish multisuser selector processing
- #      - refactor multisuer selecto with processors
- #      - replan multiuserselector
- #      - fix 8.1 part 6
- #      - fix migrations - rewrite smtp handler load
- #      - increase min version for forma4 upgrade - fix installer download file
- #      - fix cache dir and lock file on upgrade
- #      - fix 81 part 5
- #      - fix versionchecker
- #      - fix helpertool
- #      - role and groupo user selector
- #      - remove mixed in Utils::config() return type
- #      - fix version check
- #      - fix send alert
- #      - fix exception in VersionChecker when config does not exists
- #      - code refactor
- #      - fix user selector in subscription policies
- #      - fix admin profile
- #      - fix statistics graph
- #      - fix edit communication
- #      - fix tet not attempted
- #      - disable plugins during isntallation and upgrade
- #      - refactor installer grpahics
- #      - fix count LO
- #      - fix for purchase user - v4
- #      - fix purchase logic
- #      - fix template management
- #      - various fix resolved
- #      - fix learning objects
- #      - add min setting in domain config
- #      - fix learning objects
- #      - fix registration code check when registration code is not enabled - fix acl fatal errors
- #      - fix getAcl function call
- #      - update packages
- #      - wip fix replace errors
- #      - Rename all docebo classes to new Forma Classes - Rafactor DoceboUser to FormaUser enabling namespace
- #      - Refactor Docebo to Forma enabling namespace
- #      - Refactor Mysql classes enabling namespase
- #      - Fix User session serialize and deserialize
- #      - remove $GLOBALS['current_user']
- #      - remove unused classes
- #      - init Docebo replace into Forma
- #20148 -  casting boolean to object
- #      - Fix template management
- #      - fix for plugins isntallation
- #      - substitute login background img
- #      - limit english lang for install
- #      - fix for making Forma suitableto hosting installation
- #      - fix course report on evaluation register
- #20144 - : different fixes related to Grade Book
- #20139 - fix Countable exception in mail configuration
- #      - fix certificate image
- #      - fix registration with code
- #      - fix upgrade with formamigrator integrated
- #      - add formamigrator
- #      - add migration run by application not cli
- #      - fix countable - remove old event
- #      - tinymce absolute url newsletter
- #      - fix for upgrader suitable mysql5.7
- #      - fix foreign keys installer
- #      - add check and remove trailing slash
- #      - update collation
- #      - fix mysql check connection
- #      - fix for installation on mysql5.7
- #      - drop learning communication lang
- #      - fix upgrade migration and collation
- #      - fix: substitution of drop index if exists
- #      - feat: add alert to import users courses csv
- #      - New Feature - Upgrade standalone legacy
- #      - Solved the error pertaining to the upload of a new plugin by removing fclose() in pluginmanagerAdm.php.
- #      - fix api course updateDay
- #      - fix php version and base path redirect
- #      - fix(lo): track item correctly set
- #20138 -  fixed store method interface
- #      - feat(dashboardsetting): add userselector
- #      - fixes for 8.1
- #      - fix save user in session
- #      - Fix typo in lib.catalogue.php
- #      - update build template
- #      - move old template to legacy
- #      - fix taken and adapted from 334
- #      - V2 files
- #      - frontend V2
- #      - fix constructs old style
- #      - Revert "exclude former closing date logic"
- #      - fix multiuser selector
- #      - no message
- #      - cherypick add remapping events test360
- #      - cherrypick
- #      - fix taken and adapted from 334
- #      - fix menu load - fix syntax
- #      - fixes welcome block and add node
- #      - fix install
- #      - other warnings
- #      - fixes 8.1 last stage
- #20126 - typo in "self" statement
- #      - fixes for 8.1
- #20120 - fixed repeating mandatory LO on test fails
- #      - fix php version
- #      - other requested fixes
- #      - requested fixes 8.1
- #      - Fix plugin facebook google linkedin twitter for formaLMS 4.0 (GET e SESSION)
- #      - Fix plugin facebook google linkedin for formaLMS 4.0
- #      - Fix plugin conference for formaLMS 4.0
- #      - fix checkstatus redirect
- #20124 - error on test submitting
- #      - fix dashboard settings and response
- #      - fix dashboard settings
- #20123 - With force-finish the first time session is not recorded (force finish disables consequent course calls). So the first string is empty.
- #20116 - fixed
- #20117 - fixed
- #      - fix on installation
- #20116 - managed default quota value
- #20121 - Fixed query install plugin for 3.3.3 and 4.x compatibility
- #      - fix save setting when param_type is button
- #      - fix report custom field translation when selected lang is different from default lang
- #      - fix dashboard
- #20114 - Layout POPUP deleted - Added popup.html.twig
- #      - add phpcli check version
- #      - add button for regenerate lock file
- #      - load english after required language to avoid "fatal"missing constant definition"
- #      - removed double label definition in italian install language
- #      - Don't view completed courses in "my courses"
- #      - Solved - End of course marker does not working
- #      - disable warning log in mkdir directive
- #      - Extraction of course participants with Name and Surname separated columns in the detail tracing of single courses
- #      - Cast integer value for compatibility PHP8
- #      - various fix forma 4
- #      - systemcheck page implemetation
- #      - fix from subfolder installation
- #      - finish lock file and check status
- #      - file lock implementation
- #      - init exceptions and file lock
- #      - last fixes upgrade
- #      - add test button for upgrader
- #20112 - Fixes related to accessibility
- #20112 - Fixes related to accessibility
- #      - debug fixes upgrader
- #      - upgrade fixes
- #20111 - fixed dashboard admin regression
- #      - last fixes installer
- #20110 - error on empy defined dashboard
- #      - fix upgrader
- #      - update template version
- #      - update frontend icons - fix color names
- #      - adm.css a:hover
- #      - Adm.css colors
- #      - Mainly icons replacement
- #      - Subs last colors
- #      - Adj colors
- #      - Subs colors
- #      - Top menu + user panel 70%
- #      - Subs. colors
- #      - Colors
- #      - Working on colors
- #      - other fix for installer in php8
- #      - update composer libraries - fix htaccess rewrite rules for installer and upgrader
- #20109 - fixing static call in customfield class
- #      - other warning fix
- #      - fix conflict
- #      - fix session lifetime management
- #      - fix install lang
- #      - fix installer flow
- #      - fix lables installation
- #      - fix exceptions when config does not exists
- #      - fix wrong prerequisite setting during learning object copy -fix scorm path during copy when scorm file has ' in name
- #      - fix autocomplete container width that truncate suggetions
- #      - work in progress fixing installer and upgrader
- #      - fix installer htaccess
- #      - Fix 'lms.course_user.updating' that does not send current status and prev status
- #      - update changelog adding 3.3 version
- #      - finish add userselelector in course
- #      - user selector course
- #20108 - typo in path for file inclusion
- #      - fix PluginManagerAdm warnings
- #      - remove unused functions
- #      - fix create user
- #      - frontend build
- #      - finish userselector area lms
- #      - add userselector to area lms menu
- #      - fix grid object count
- #      - Cambiato alcune funzioni da non-static e static e risolto gli errori con la compatibilità con i parent
- #      - Aggiunto __contruct ad alcune classi e risolto l'errori con i parent:: sbagliati
- #      - Sosotituito i nomi dei costruttori di alcuni classi con __construct e risolto gli errori con parent::constructor
- #      - Eliminato il file lib.plugin.php
- #      - Risolto l'errore con la compatibilità delle classi dei vari plugin
- #      - Risolto l'errore con la creazione dei directory
- #      - Passato un'array invece di un null al metodo array_unshift()
- #      - finish upgrader
- #      - Aggiunto contruct ad alcune classi
- #      - fix grid object count
- #      - upgrader and cleaning data
- #20107 - setting variables to array type.
- #      - fix io task import user send email
- #      - fix elearning icon size
- #      - add function twigmanager - fix plugin session management
- #      - upgrade events working
- #20106 - Adding missing variables declaration
- #      - Fixes folderTreeMultiUser as reported by mail
- #      - merge edo in dev
- #      - Fix descendants
- #      - 99%
- #      - 90% completed
- #      - Toggle foldeTree
- #      - Continuazione folder tree userselector
- #      - Form data sent
- #      - init org data selector jsonoutput
- #      - Fix php 8.1 errors
- #      - add docs and tools
- #      - fix docs
- #      - fix bootloader
- #      - refinement and translations
- #      - migration completed
- #      - complete migration part
- #      - annotation completed
- #      - updating index entity
- #      - remove migrations
- #      - mail refactor
- #      - insert and update
- #20099 - php 8.1 update
- #20096 - Fixing access to Course, General Forum, Dashboard, Catalogue, Course, User Management
- #      - fix upgrader
- #      - fix custom field loading in user manager - improve query speed
- #20094 - fixed code for enabling access to forma.lms
- #      - refiniement user selector
- #      - aggiunto __construct a alcuni classi
- #      - Eliminato il file lib.domxml4.php e tutti isuoi riferimenti
- #      - Tolti le righe di codice con 'each'
- #      - eliminato il file docebodb.mysql.php e tutti i suoi riferimenti
- #      - Risolto l'errore con i parametri attesi di sprintf
- #      - Risolto gli errori di PhpElementIsNotAvailableInCurrentPhpVersionInspection
- #      - fix course stats ajax url
- #      - various fix on dashboard blocks
- #20105 - different fixes for php 8.1 compatibility new sms management: enabling or disabling trough config.php param fixing pull donw menu for choosing new template on new node chart creation
- #      - fix language and attachment link report
- #      - fix load template from plugins
- #      - fix warnings - fix function static
- #      - fix order posflat on building multilevel object stats tree using dynamic id based on table
- #      - fix dashboard block calendar enabling actions
- #      - fix treeview teacher area query string too long
- #      - fix order posflat on building multilevel object stats tree
- #      - fix multiuserselector haschildren attribute
- #      - fix user selector
- #20093 - removing php files under template/standards/layout and appCore/class/class.*.php files
- #20093 - fixes related to scorm
- #      - reorder query in migrations
- #20102 - fixes related to Learning Objects
- #20093 - Fixes related to Course
- #20100 - Different fixes; removed support for PHP 4.0 xml management
- #      - finish new response orgdataselector
- #      - add object useful to orgdata node reponses
- #      - init org data selector jsonoutput
- #20100 - Different fixes
- #      - fix array_unique
- #      - Fix php 8.1 errors
- #      - add docs and tools
- #      - fix docs
- #      - fix bootloader
- #      - add checkdbconnections tatic
- #      - clean install folder
- #      - refinement and translations
- #      - fix role in 3.3 when user become from 1.4
- #      - adding progress bar
- #      - finalization install
- #20099 - php 8.1 update
- #      - migration completed
- #20098 - added static to function call;
- #20097 - fixing constructor call
- #20096 - Fixing access to Course, General Forum, Dashboard, Catalogue, Course, User Management
- #      - fix upgrader
- #      - fix event
- #      - fix custom field loading in user manager - improve query speed
- #20094 - fixed code for enabling access to forma.lms
- #      - fix course report test recalculation
- #20091 - fix update item
- #20090 - fix poll course completion when is setted as end course marker.
- #      - fix api course
- #      - fix prerequisites typo
- #      - fix exception
- #20092 - added missing dates course deletion
- #      - complete migration part
- #20089 - applying enrollment rules using user API
- #      - add trait timestamp
- #20088 - fix Course copy does not copy learning object correctly
- #20087 - fix send unsubscribe notification to student
- #      - annotation completed
- #      - correct merge error
- #20086 - deleted direct inclusion line and relative folders
- #      - updating index entity
- #      - remove migrations
- #      - update npm packaged and frontend build after merge
- #      - update composer lock after merge
- #      - fix count student and list certificate for admin users
- #      - fix courses dashboard block dates - prefixer
- #      - homecatalogue fix categories show when there isn't visible to all courses -  fix warnings
- #20085 - fix and refactor home catalogue
- #      - fix order
- #      - adminmanager add
- #      - get preselected data
- #      - communication injection
- #      - add search input
- #      - all rendered
- #      - porting formatable step 3
- #      - main config formatable
- #      - build main js problem
- #      - fix courses dashboard block dates - prefixer
- #20085 - fix and refactor home catalogue
- #      - creation domainhandler
- #      - mail refactor
- #      - insert and update
- #      - fix report user course selector
- #      - implemente doctrine
- #      - update config
- #      - creation domainhandler
- #      - mail refactor

---------------------------------------------------------------------------------------
forma.lms 3.3.22
---------------------------------------------------------------------------------------
Release date: 2024 february

- #      - Fix various graphic and style improvements
- #      - upgrade version
- #      - Fix "Download" button position on "MyCertificates" user area
- #      - Fix handling accents when right click renaming
- #      - Fix FolderView delete file message not showing
- #      - Fix Context Menu delete message not showing
- #      - Fix Link header translation
- #      - Change submit when editing a file to orange
- #      - Remove double quote on edit dashboard settings and directory class
- #      - Remove double '<<' on Wiki module
- #      - Fix invalid lang codes for language files
- #      - Fix "X" alignment on file dropzone and upgraded TinyMCE to 5.10.9
- #      - Remove double '<' on User Registration
- #      - Fix FAQ title rendering
- #      - Fix PT-BR install translation and translates "Yes/No" fields
- #      - Fix reference for missing image on FAQ
- #      - Make Admin Area icons sprite transparent
- #      - Translate Status column and Capitalize "by" column
- #      - Fix _MOVE_ORGBRANCH translation
- #      - Update kbcategorize.php
- #      - Update _orgchart_selector.php
- #      - Translate User Pontuation column tile on Grade book details
- #      - Pass dropzone as Twig param
- #      - Translate success upload learning object file message
- #      - Fix translation label rendering on checkboxes at student attendance list
- #      - Fix "modify time table" on student attendance dates list
- #      - Fix searchbox float of certificates
- #      - Update certificate.userstat.php
- #      - FolderView translation handling
- #      - Add translation for Context Menu and Folder View actions on courses
- #      - Translate fields from User Profile (View)
- #      - Update lostpwd.html.twig
- #      - [User Register] Remove '<<' from _BACK str and Uppercase on language dropdown
- #      - Add missing space on Users section of dashboard
- #      - Fix subscribe user "plus" button on assign users to course page
- #      - Do not use slashes on _homerepo and _repo DB
- #      - Fix HTML page title rendering (and possible other learning objects too)
- #      - Fix 404 error when loading jQuery Datepicker for EN users
- #      - Update show.php
- #      - Update list.php
- #      - Fix translation not being applied on Language management
- #      - Fix radio text alignment
- #      - Fix "Menu Course" translation
- #      - Fix translation not being applied on Teacher Area
- #      - Added missing translation relations
- #      - Multilanguage TinyMCE and bugfixes

---------------------------------------------------------------------------------------
forma.lms 3.3.21
---------------------------------------------------------------------------------------
Release date: 2024 february

- #      - fix subject dynamic content in mail
- #      - events on userselector columns
- #      - fix scorm time parser
- #      - fix scorm sessiontime count
- #      - fix connector import user language logic
- #      - other fix html page escape
- #      - fix htmlpage update query
- #      - fix deleteLearningObjects API
- #      - add version files
- #      - fix advanced search in user widget
- #      - sanitize wildcard in check username duplicates
- #      - fix default lang in io task user import
- #      - fix calendar
- #      - remove course description in getanswertest XML response
- #      - fix multimod subscription in users array

---------------------------------------------------------------------------------------
forma.lms 3.3.17
---------------------------------------------------------------------------------------
Release date: 2023 november

- #      - update to readme
- #      - fix orphan commontrack
- #      - #20181 - Student upload a Zip file through the plugin upload
- #      - #20180 - Student upload a Zip file through the SCORM importer feature
- #      - #20179 - SQL injection vulnerability in appLms/ajax.adm_server.php?r=widget/userselector/getusertabledata - CVE-2022-42924
- #      - #20070 - Vulnerability - SQL Injection in adm/mediagallery/delete - CVE-2022-42923
- #      - #20069 - Vulnerability - XSS in appLms/index.php?modname=faq&op=play - CVE-2022-41679
- #      - #20178 - Vulnerability stored-XSS in management of educational objects, through the FAQ title - CVE-2023-46693
- #      - #20177 - Vulnerability stored-XSS in the title of discussions in the course forums - CVE-2023-46693
- #      - #20176 - Vulnerability stored-XSS in the title parameter of the course advice - CVE-2023-46693
- #      - fix test
- #      - fix pattern for forma include
- #      - fix on assigning template in creating new folder

---------------------------------------------------------------------------------------
forma.lms 3.3.15
---------------------------------------------------------------------------------------
Release date: 2023 october

- #      - Fix user stats
- #      - fix form replace
- #      - fix upgrade communication and category menu
- #      - fix require question type files with forma::inc
- #      - fix dashboard middle area user
- #      - add reset_field_if_not_set,use_default_password,default_password in iotask docebouser connector config
- #      - add orgchart management in update user api
- #      - add orgchart management in update user api
- #      - fix custom field check when user insert 0 as value
- #      - fix all require once for lib_profile.php
- #      - fix custom field check when user insert 0 as value
- #      - fix query for field show when textentry is numeric when fields filter is active
- #      - fix 0 in session
- #      - fix ssl encryption
- #      - fix field show when textentry is numeric
- #      - Fix dashboard next courses block
- #      - fix 3.3.8 add index query to solve if index exists

---------------------------------------------------------------------------------------
forma.lms 3.3.13
---------------------------------------------------------------------------------------
Release date: 2023 september

- #      - Fix dashboard next courses block

---------------------------------------------------------------------------------------
forma.lms 3.3.11
---------------------------------------------------------------------------------------
Release date: 2023 august

- #      - add fallback to ',' '|' and space separator fo CC and CCN in mailer
- #      - fix session in select node usermanagement
- #      - fix english regional setting date separator

---------------------------------------------------------------------------------------
forma.lms 3.3.10
---------------------------------------------------------------------------------------
Release date: 2023 july

- #      - Fix root required field in advanced registration when there isn't reg code
- #      - add query in upgrader
- #      - fix feedback calculation


---------------------------------------------------------------------------------------
forma.lms 3.3.9
---------------------------------------------------------------------------------------
Release date: 2023 june

- #      - fix getUsersFieldEntryData in lib.field.php for Country custom field
- #      - #20153: fixed http protocol setting
- #      - #20152: managed "Cancel" button
- #      - fix lang
- #      - fix performance exception
- #      - fix test update modality
- #      - Fix require path with static /../ in string.
- #      - create 3.3.8 to insert in install ad upgrade lost query index
- #      - Fix send Alert in subscription
- #      - functions refactor
- #      - fix question bank
- #      - fix forma table rows when text is HTML
- #      - add translation in folder view learning object status and action
- #      - add color management in dashboardblock attendancegraph
- #      - fix api deleteDay
- #      - fix api updateDay
- #      - fix upgrade sql
- #      - #20146: added missing SQL instructions
- #      - fix purchase user logic
- #      - first commit for versioning
- #      - fix course report duplicates
- #      - fix remove dates
- #      - fix certificate image
- #      - fix certificate image
- #      - fix registration with code
- #      - fix dashboard permission

---------------------------------------------------------------------------------------
forma.lms 3.3.5
---------------------------------------------------------------------------------------
Release date: 2023 april

- #      - fix dashboard permission
- #      - fix countable - remove old event
- #      - try relative false in newsletter
- #      - Fix frontend presence
- #      - fix classroom presence - fix classroom date day save
- #      - add setter and getter to docebo user
- #      - feat: add alert on import csv on course
- #      - fix api course updateDay
- #      - fix(lo): tracking item correctly set
- #      - fix id day to solve API addDay and updateDay
- #      - fix installer
- #      - #19842 - User Object grid - Pagination with many objects
- #      - fix save user in session
- #      - Fix typo in lib.catalogue.php
- #      - fix constructs old style
- #      - add test question score show in report management
- #      - add remapping events from test360
- #      - add event remapping
- #      - Revert "exclude former closing date logic"
- #      - Fix Get functions to read env variables if is defined
- #      - fix dashboard permission
- #      - exclude former closing date logic
- #      - fix dashboard menu
- #      - fix menu load
- #      - fixes welcome block and add node
- #      - fix dashboard settings and response
- #      - fix plugin manager
- #      - fix error dashboard layout
- #      - upgrade version file
- #      - fix dashboard
- #      - fix save setting when param_type is button - code reindent
- #      - fix report custom field translation when selected lang is different from default lang

---------------------------------------------------------------------------------------
forma.lms 3.3.3
---------------------------------------------------------------------------------------
Release date: 2023 january

- #      - fix mysql 5.6 query issue in 3.3.0 upgrader query
- #      - fix PluginManagerAdm warnings
- #      - fix grid object count
- #      - fix grid object count
- #      - fix io task import user send email
- #      - fix forum ticket 14334
- #      - fix elearning icon size
- #      - add function twigmanager - fix plugin session management
- #      - FE build
- #      - replace http to https in skebby gateway
- #      - fix course stats ajax url
- #      - various fix on dashboard blocks
- #      - fix language and attachment link report
- #      - fix dashboard block calendar enabling actions
- #      - fix order posflat on building multilevel object stats tree using dynamic id based on table
- #      - fix warnings - fix function static
- #      - fix messages
- #      - fix load template from plugins
- #      - fix treeview teache area query string too long
- #      - fix order posflat on building multilevel object stats tree
- #      - fix custom field translation
- #      - fix session lenght
- #      - fix custom field visualization in report
- #      - fix catalogue course access control
- #      - fix cron report

---------------------------------------------------------------------------------------
forma.lms 3.3.2
---------------------------------------------------------------------------------------
Release date: 2022 october

- #      - add index to learning_testquestanswer, learning_coursereport, core_field_userentry tables to speedup pages loading
- #      - fix course report test recalculation
- #20091 - fix update item
- #20090 - fix poll course completion when is setted as end course marker.
- #      - fix api course
- #      - fix prerequisites typo

---------------------------------------------------------------------------------------
forma.lms 3.3.1
---------------------------------------------------------------------------------------
Release date: 2022 october

- #20088 - fix Course copy does not copy learning object correctly
- #20087 - fix send unsubscribe notification to student


---------------------------------------------------------------------------------------
forma.lms 3.3.0
---------------------------------------------------------------------------------------
Release date: 2022 september

- #      - implement new session management with more session handlers
- #      - refactoring of project autoloading with the activation of namespaces
- #      - fix report user course selector
- #      - fix count student and list certificate for admin users
- #20085 - complete catalog refactor fix
- #20085 - fix and refactor home catalogue
- #      - fix show user catalogue
- #      - fix export link in reservation page
- #      - fix date show in courses block
- #      - fix courses dashboard block dates
- #      - fix twig extensions
- #      - fix and refactor course copy
- #      - fix and refactor check learning object prerequisites
- #      - fix pagination in enrollRules
- #      - homecatalogue fix categories show when there isn't visible to all courses
- #      - hide courses with show_rules not equal to 0
- #20085 - fix and refactor home catalogue
- #      - add index in core_setting table
- #      - fix user handling on duplicate course
- #20084 - missing installation of dashboard_permission table.
- #      - create folder missing object creation fix
- #      - fix twig cache and deleted user list only for superadmin
- #      - fix dashboard welcome block
- #20083 - fixed using the right param
- #20082 - added calendarID parameter on learning_course_date table
- #20081 - Undo button: from submit to button and added a history.back command
- #20079 - Fixed: "Directly play the first Learning Object in the player" in course setting does not work
- #20077 - fix error err_http2_protocol_error download certificate
- #20076 - UserManagementAdm: in  addFolder method added saving of template name; UsermanagementAdmController in createfolder method added managing of default template in case of admin without "org modify" permission.

---------------------------------------------------------------------------------------
forma.lms 3.2.1
---------------------------------------------------------------------------------------
Release date: 2022 june

- #20071 - Vulnerability - privilege escalation
- #20067 - Vulnerability - SQL Injection in alms/subscription/getlist
- #20068 - Vulnerability - SQL Injection in mycertificate/getMyCertificates
- #20070 - Vulnerability - SQL Injection in adm/mediagallery/delete

---------------------------------------------------------------------------------------
forma.lms 3.2.0
---------------------------------------------------------------------------------------
Release date: 2022 March

- #      - Add Dropzone for upload files
- #20052 - fix home page
- #20051 - edit communication not working and not dropzone
- #20047 - graphic fix news upload file
- #20047 - graphic fix news and communication
- #20046 - mail link report and transaltion for users
- #      - update template version number
- #20045 - remove seconds from next course widget
- #      - fix scorm overlay
- #20043 - Add decimal in course credits
- #20041 fix widget communications and news
- #20039 - Date not saved in coursepath
- #      - Fix course widget
- #      - add css and js versioning bind with template version
- #20036 - fixed query related to user status
- #      - fix scorm play
- #      - new views modules news and communications
- #      - update comunication html class scorm launcher
- #      - fix folder view eventListeners for student area
- #20031 - create custom fields for classroom
- #20022 - fixed  addMenu method
- #20007 - fixed not sanitized input param

---------------------------------------------------------------------------------------
forma.lms 3.1.0
---------------------------------------------------------------------------------------
Release date: 2022 March

- Reformat all php code files , support PHP 7.4 syntax

- addes new language lithuanian - icon SPRITE + css
- Update from lang site 2022/03/28
- fix menu course translation
- #20005 - Vulnerability CVE-2022-26958 - remove vulnerability and check signature in RelayState
- #20008 - Vulnerability CVE-2022-27301 CVE-2022-27302 - Unsafe require_once() can lead to arbitrary LFI
- #20009 - Vulnerability CVE-2022-27303 - Unsafe saving of user-supplied values in SESSION
- #20050 - fix button translate
- #20049 - fix API user/mycourses does not show subscription date for classroom course
- #20048 - load plugins in order by priority
- #20042 - User profile show does not show custom fields
- #20044 - dashboard certificate generation
- #20040 - fix accented chars in print pdf certificate
- #      - Fix privacy and password renewal check
- #20038 - fix scorm close tracking
- #20037 - change days of classroom courses
- #20033 - Error date "active from / to" in course path
- #20034 - show tabs button on dashboard menu
- #      - fix field show in registration
- #19690 - fixed call to parent constructor
- #19690 - fixed class constructor
- #20032 - publishing date makes courses invisiible for everyone
- #      - fix api
- #      - add idcourse filter in show courses
- #20030 - initial resolution for reorder learningobjects folder
- #20028 - added default managing
- #20027 - fix Dynamic link missing in some email send
- #      - change to dashboard calendar
- #20026 - dashboard calendar dates duplicate elearning
- #20025 - Add no value in select fields in setting
- #20024 - added forma::inc check
- #20023 - fix Docebo user connector remove users from all subscription roles
- #20021 - block certificates dashboard query and html chars on block announcements fix
- #      - add specs manifest for plugins
- #20019 - Deep changes on plugin manager for dependencies
- #20007 - fixed not sanitized input param
- #20020 - API Authenticate does not working
- #20018 - Land translation management does not translate all selected rows
- #20017 - Fix event names 
- #20016 - Fix Dynamic link does not work in user registration
- #20015 - missing translations for context menu in LO
- #20014 - impossible access to course tab detail for student
- #20013 - empty selction in locations assignment not working
- #20010 - reprise:fix for count students in class courses
- #20012 - admin can delete superadmin
- #20011 - fix Iotask not suspend/delete users
- #20010 - filter admin id for list certificate and course students
- #20006 - fix filter on aggregated certificates list and date on next courses widget
- #20004 - fix duplicate events on calendar day
- #19768 - fix break in foreach cycle that not permit to shows aggregate certificates 
- #19768 - add logic to show generated certificates whatever course status has 
- #20003 - fix API course updateUserSubscription does not set date_complete if status is END
- #20001 - API updateDay give : Day does not exists although day exists
- #19998 - fix check presence
- #      - Add LO translation
- #19996 - fix admin can delete super admin.
- #      - fix add day api course


---------------------------------------------------------------------------------------
forma.lms 3.0.2
---------------------------------------------------------------------------------------
Release date: 2022 january

-- internal release

- #20016 - Fix Dynamic link does not work in user registration
- #20015 - missing translations for context menu in LO
- #20014 - impossible access to course tab detail for student
- #20013 - empty selction in locations assignment not working
- #20010 - fix for count students in class courses
- #20011 - fix Iotask not suspend/delete users
- #20012 - admin can delete superadmin
- #20010 - filter admin id for list certificate and course students
- #20006 - fix filter on aggregated certificates list and date on next courses widget
- #20004 - fix duplicate events on calendar day
- #19768 - fix break in foreach cycle that not permit to shows aggregate certificates
- #19768 - add logic to show generated certificates whatever course status has
- #20003 - fix API course updateUserSubscription does not set date_complete if status is END
- #20001 - API updateDay give : Day does not exists although day exists
- #19998 - fix check presence
- #19996 - fix admin can delete super admin.

---------------------------------------------------------------------------------------
forma.lms 3.0.1
---------------------------------------------------------------------------------------
Release date: 2021 december

- #19995 - CVE-2021-43136 Vulnerabity - resolve sso vulnerability
- #19975 - fix Certificate special characters print error
- #19994 - Sub Admin and user selector widget Commented out some code rows;deletion to be evaluated for future
- #19985 - #Revert0 fix user selector orgchart error
- #19993 - fix api course addClassroom
- #      - Fix installer and upgrader mysql Check
- #19992 - fixed class constructor
- #19991 - changed orgchart parameter
- #19989 - fix aggregate certificate API assign meta user
- #19989 - fix aggregate certificate detail table
- #19990 - add feature mail to teachers in upload course file
- #19989 - Fix aggregate certificate category selector
- #      - Fix Link categories - goto MyCourses page with the category ID and apply filter
- #19988 - Fix error when try to delete classroom course with dates
- #19987 - Fix error in teacher area when user does not have permission to one of organitazion|home|public repo
- #19986 - fix resize image and increase min image width
- #19978 - fix total hours in meta certificate layout
- #19985 - fix user selector orgchart error
- #19978 - fix meta certificate layout
- #19979 - User/object Grid Cannot check Item object type:. missing default param on class constructor.
- #      - Add paramter validation in course API
- #19984 - fix error 500 in aggregate certificate view detail
- #19981 - fix addDay API adding validation that idDate exist in course
- #      - Fix certificate layout
- #      - Api rename e delete
- #19978 - fix meta certificate layout
- #19978 - fix aggregated certificates
- #19978 - Fix aggregate certificate list that shows incorrect course path
- #19978 - fix API addMetaCertificates 
- #19978 - fix 3000 upgrade query 
- #19978 - fix aggregate certificate certificate Style#19977
- #19978 - fix exception in getanswertest and refactor old while with foreach cycles
- #19976 - fix You can't access in new learning object area for normal user.
- #19964 - fix baseUrl generation
- #      - Revert TwigManager addExtension function that was lost
- #19974 - fix issue when block does not have enabledActions
- #19974 - fix calendar
- #19975 - fix Certificate special characters print error
- #      - Revert correct namespace
- #      - Add permissions in event dispatch to permit check in events listeners
- #19964 - fix baseUrl generation
- #19971 - fix addDay API
- #19970 - Ripristinate event to interact with lo objects with new event system
- #19969 - remove empty modules in land export
- #19968 - Fix exception if createModule try to instantiate a class that does not exists
- #19967 - Fix meta certificate date formats for tags [meta_complete] [meta_inscr] [meta_access]
- #19963 - fix banner widget and video modal load.
- #19964 - Fix baseurl calculate when request has implicit php file
- #19962 - Fix lang code management in dashboardCalendar to get correct langCode
- #      - Fix dashboard block load
- #      - Add TWIG Template extensions functions
- #19961 - replaced old event "lms.course.deleted" and added "lms.course.deleting"
- #19960 - Typo in template folder extension - ripristinate "translate" twig function as "deprecated"
- #19959 - Fix plugin manager that not show errors during installation/upgrade
- #19958 - replace lost TwigManager functions
- #19961 - removed old events and deprecated unused functions
- #19957 - added course_box_description


---------------------------------------------------------------------------------------
forma.lms 3.0.0
---------------------------------------------------------------------------------------
Release date: 2021 november

-  Complete PHP 7.4 compatibility
-  Improved PHP event management system
-  New Dashboard feature
-  New refactored and redesigned LO Management feature
-  Refactored language management
-  Refactored and improved "Aggregated Certificate" feature
-  Refactored and redesigned "Course Info" module
-  Refactored and redesigned dates management for classroom courses
-  Outlook calendar integration
-  Improved multi template management
-  API improvement and postman integration
-  Layout restyling
-  Refactored MyCourses and Catalog modules 
-  Improveded overbooking and waiting list management

Plus tons and tons of bugfixes, minor improvements, core libraries updates and optimizations

